// Code generated by ent, DO NOT EDIT.

package localbreach

import (
	"time"

	"entgo.io/ent/dialect/sql"
	"entgo.io/ent/dialect/sql/sqlgraph"
	"git.dotya.ml/mirre-mt/pcmt/ent/predicate"
	"github.com/google/uuid"
)

// ID filters vertices based on their ID field.
func ID(id uuid.UUID) predicate.LocalBreach {
	return predicate.LocalBreach(sql.FieldEQ(FieldID, id))
}

// IDEQ applies the EQ predicate on the ID field.
func IDEQ(id uuid.UUID) predicate.LocalBreach {
	return predicate.LocalBreach(sql.FieldEQ(FieldID, id))
}

// IDNEQ applies the NEQ predicate on the ID field.
func IDNEQ(id uuid.UUID) predicate.LocalBreach {
	return predicate.LocalBreach(sql.FieldNEQ(FieldID, id))
}

// IDIn applies the In predicate on the ID field.
func IDIn(ids ...uuid.UUID) predicate.LocalBreach {
	return predicate.LocalBreach(sql.FieldIn(FieldID, ids...))
}

// IDNotIn applies the NotIn predicate on the ID field.
func IDNotIn(ids ...uuid.UUID) predicate.LocalBreach {
	return predicate.LocalBreach(sql.FieldNotIn(FieldID, ids...))
}

// IDGT applies the GT predicate on the ID field.
func IDGT(id uuid.UUID) predicate.LocalBreach {
	return predicate.LocalBreach(sql.FieldGT(FieldID, id))
}

// IDGTE applies the GTE predicate on the ID field.
func IDGTE(id uuid.UUID) predicate.LocalBreach {
	return predicate.LocalBreach(sql.FieldGTE(FieldID, id))
}

// IDLT applies the LT predicate on the ID field.
func IDLT(id uuid.UUID) predicate.LocalBreach {
	return predicate.LocalBreach(sql.FieldLT(FieldID, id))
}

// IDLTE applies the LTE predicate on the ID field.
func IDLTE(id uuid.UUID) predicate.LocalBreach {
	return predicate.LocalBreach(sql.FieldLTE(FieldID, id))
}

// Name applies equality check predicate on the "name" field. It's identical to NameEQ.
func Name(v string) predicate.LocalBreach {
	return predicate.LocalBreach(sql.FieldEQ(FieldName, v))
}

// Date applies equality check predicate on the "date" field. It's identical to DateEQ.
func Date(v time.Time) predicate.LocalBreach {
	return predicate.LocalBreach(sql.FieldEQ(FieldDate, v))
}

// Description applies equality check predicate on the "description" field. It's identical to DescriptionEQ.
func Description(v string) predicate.LocalBreach {
	return predicate.LocalBreach(sql.FieldEQ(FieldDescription, v))
}

// IsVerified applies equality check predicate on the "is_verified" field. It's identical to IsVerifiedEQ.
func IsVerified(v bool) predicate.LocalBreach {
	return predicate.LocalBreach(sql.FieldEQ(FieldIsVerified, v))
}

// ContainsPasswords applies equality check predicate on the "contains_passwords" field. It's identical to ContainsPasswordsEQ.
func ContainsPasswords(v bool) predicate.LocalBreach {
	return predicate.LocalBreach(sql.FieldEQ(FieldContainsPasswords, v))
}

// ContainsHashes applies equality check predicate on the "contains_hashes" field. It's identical to ContainsHashesEQ.
func ContainsHashes(v bool) predicate.LocalBreach {
	return predicate.LocalBreach(sql.FieldEQ(FieldContainsHashes, v))
}

// ContainsEmails applies equality check predicate on the "contains_emails" field. It's identical to ContainsEmailsEQ.
func ContainsEmails(v bool) predicate.LocalBreach {
	return predicate.LocalBreach(sql.FieldEQ(FieldContainsEmails, v))
}

// ContainsUsernames applies equality check predicate on the "contains_usernames" field. It's identical to ContainsUsernamesEQ.
func ContainsUsernames(v bool) predicate.LocalBreach {
	return predicate.LocalBreach(sql.FieldEQ(FieldContainsUsernames, v))
}

// HashType applies equality check predicate on the "hash_type" field. It's identical to HashTypeEQ.
func HashType(v string) predicate.LocalBreach {
	return predicate.LocalBreach(sql.FieldEQ(FieldHashType, v))
}

// HashSalted applies equality check predicate on the "hash_salted" field. It's identical to HashSaltedEQ.
func HashSalted(v bool) predicate.LocalBreach {
	return predicate.LocalBreach(sql.FieldEQ(FieldHashSalted, v))
}

// HashPeppered applies equality check predicate on the "hash_peppered" field. It's identical to HashPepperedEQ.
func HashPeppered(v bool) predicate.LocalBreach {
	return predicate.LocalBreach(sql.FieldEQ(FieldHashPeppered, v))
}

// CreatedAt applies equality check predicate on the "created_at" field. It's identical to CreatedAtEQ.
func CreatedAt(v time.Time) predicate.LocalBreach {
	return predicate.LocalBreach(sql.FieldEQ(FieldCreatedAt, v))
}

// NameEQ applies the EQ predicate on the "name" field.
func NameEQ(v string) predicate.LocalBreach {
	return predicate.LocalBreach(sql.FieldEQ(FieldName, v))
}

// NameNEQ applies the NEQ predicate on the "name" field.
func NameNEQ(v string) predicate.LocalBreach {
	return predicate.LocalBreach(sql.FieldNEQ(FieldName, v))
}

// NameIn applies the In predicate on the "name" field.
func NameIn(vs ...string) predicate.LocalBreach {
	return predicate.LocalBreach(sql.FieldIn(FieldName, vs...))
}

// NameNotIn applies the NotIn predicate on the "name" field.
func NameNotIn(vs ...string) predicate.LocalBreach {
	return predicate.LocalBreach(sql.FieldNotIn(FieldName, vs...))
}

// NameGT applies the GT predicate on the "name" field.
func NameGT(v string) predicate.LocalBreach {
	return predicate.LocalBreach(sql.FieldGT(FieldName, v))
}

// NameGTE applies the GTE predicate on the "name" field.
func NameGTE(v string) predicate.LocalBreach {
	return predicate.LocalBreach(sql.FieldGTE(FieldName, v))
}

// NameLT applies the LT predicate on the "name" field.
func NameLT(v string) predicate.LocalBreach {
	return predicate.LocalBreach(sql.FieldLT(FieldName, v))
}

// NameLTE applies the LTE predicate on the "name" field.
func NameLTE(v string) predicate.LocalBreach {
	return predicate.LocalBreach(sql.FieldLTE(FieldName, v))
}

// NameContains applies the Contains predicate on the "name" field.
func NameContains(v string) predicate.LocalBreach {
	return predicate.LocalBreach(sql.FieldContains(FieldName, v))
}

// NameHasPrefix applies the HasPrefix predicate on the "name" field.
func NameHasPrefix(v string) predicate.LocalBreach {
	return predicate.LocalBreach(sql.FieldHasPrefix(FieldName, v))
}

// NameHasSuffix applies the HasSuffix predicate on the "name" field.
func NameHasSuffix(v string) predicate.LocalBreach {
	return predicate.LocalBreach(sql.FieldHasSuffix(FieldName, v))
}

// NameEqualFold applies the EqualFold predicate on the "name" field.
func NameEqualFold(v string) predicate.LocalBreach {
	return predicate.LocalBreach(sql.FieldEqualFold(FieldName, v))
}

// NameContainsFold applies the ContainsFold predicate on the "name" field.
func NameContainsFold(v string) predicate.LocalBreach {
	return predicate.LocalBreach(sql.FieldContainsFold(FieldName, v))
}

// DateEQ applies the EQ predicate on the "date" field.
func DateEQ(v time.Time) predicate.LocalBreach {
	return predicate.LocalBreach(sql.FieldEQ(FieldDate, v))
}

// DateNEQ applies the NEQ predicate on the "date" field.
func DateNEQ(v time.Time) predicate.LocalBreach {
	return predicate.LocalBreach(sql.FieldNEQ(FieldDate, v))
}

// DateIn applies the In predicate on the "date" field.
func DateIn(vs ...time.Time) predicate.LocalBreach {
	return predicate.LocalBreach(sql.FieldIn(FieldDate, vs...))
}

// DateNotIn applies the NotIn predicate on the "date" field.
func DateNotIn(vs ...time.Time) predicate.LocalBreach {
	return predicate.LocalBreach(sql.FieldNotIn(FieldDate, vs...))
}

// DateGT applies the GT predicate on the "date" field.
func DateGT(v time.Time) predicate.LocalBreach {
	return predicate.LocalBreach(sql.FieldGT(FieldDate, v))
}

// DateGTE applies the GTE predicate on the "date" field.
func DateGTE(v time.Time) predicate.LocalBreach {
	return predicate.LocalBreach(sql.FieldGTE(FieldDate, v))
}

// DateLT applies the LT predicate on the "date" field.
func DateLT(v time.Time) predicate.LocalBreach {
	return predicate.LocalBreach(sql.FieldLT(FieldDate, v))
}

// DateLTE applies the LTE predicate on the "date" field.
func DateLTE(v time.Time) predicate.LocalBreach {
	return predicate.LocalBreach(sql.FieldLTE(FieldDate, v))
}

// DescriptionEQ applies the EQ predicate on the "description" field.
func DescriptionEQ(v string) predicate.LocalBreach {
	return predicate.LocalBreach(sql.FieldEQ(FieldDescription, v))
}

// DescriptionNEQ applies the NEQ predicate on the "description" field.
func DescriptionNEQ(v string) predicate.LocalBreach {
	return predicate.LocalBreach(sql.FieldNEQ(FieldDescription, v))
}

// DescriptionIn applies the In predicate on the "description" field.
func DescriptionIn(vs ...string) predicate.LocalBreach {
	return predicate.LocalBreach(sql.FieldIn(FieldDescription, vs...))
}

// DescriptionNotIn applies the NotIn predicate on the "description" field.
func DescriptionNotIn(vs ...string) predicate.LocalBreach {
	return predicate.LocalBreach(sql.FieldNotIn(FieldDescription, vs...))
}

// DescriptionGT applies the GT predicate on the "description" field.
func DescriptionGT(v string) predicate.LocalBreach {
	return predicate.LocalBreach(sql.FieldGT(FieldDescription, v))
}

// DescriptionGTE applies the GTE predicate on the "description" field.
func DescriptionGTE(v string) predicate.LocalBreach {
	return predicate.LocalBreach(sql.FieldGTE(FieldDescription, v))
}

// DescriptionLT applies the LT predicate on the "description" field.
func DescriptionLT(v string) predicate.LocalBreach {
	return predicate.LocalBreach(sql.FieldLT(FieldDescription, v))
}

// DescriptionLTE applies the LTE predicate on the "description" field.
func DescriptionLTE(v string) predicate.LocalBreach {
	return predicate.LocalBreach(sql.FieldLTE(FieldDescription, v))
}

// DescriptionContains applies the Contains predicate on the "description" field.
func DescriptionContains(v string) predicate.LocalBreach {
	return predicate.LocalBreach(sql.FieldContains(FieldDescription, v))
}

// DescriptionHasPrefix applies the HasPrefix predicate on the "description" field.
func DescriptionHasPrefix(v string) predicate.LocalBreach {
	return predicate.LocalBreach(sql.FieldHasPrefix(FieldDescription, v))
}

// DescriptionHasSuffix applies the HasSuffix predicate on the "description" field.
func DescriptionHasSuffix(v string) predicate.LocalBreach {
	return predicate.LocalBreach(sql.FieldHasSuffix(FieldDescription, v))
}

// DescriptionIsNil applies the IsNil predicate on the "description" field.
func DescriptionIsNil() predicate.LocalBreach {
	return predicate.LocalBreach(sql.FieldIsNull(FieldDescription))
}

// DescriptionNotNil applies the NotNil predicate on the "description" field.
func DescriptionNotNil() predicate.LocalBreach {
	return predicate.LocalBreach(sql.FieldNotNull(FieldDescription))
}

// DescriptionEqualFold applies the EqualFold predicate on the "description" field.
func DescriptionEqualFold(v string) predicate.LocalBreach {
	return predicate.LocalBreach(sql.FieldEqualFold(FieldDescription, v))
}

// DescriptionContainsFold applies the ContainsFold predicate on the "description" field.
func DescriptionContainsFold(v string) predicate.LocalBreach {
	return predicate.LocalBreach(sql.FieldContainsFold(FieldDescription, v))
}

// IsVerifiedEQ applies the EQ predicate on the "is_verified" field.
func IsVerifiedEQ(v bool) predicate.LocalBreach {
	return predicate.LocalBreach(sql.FieldEQ(FieldIsVerified, v))
}

// IsVerifiedNEQ applies the NEQ predicate on the "is_verified" field.
func IsVerifiedNEQ(v bool) predicate.LocalBreach {
	return predicate.LocalBreach(sql.FieldNEQ(FieldIsVerified, v))
}

// ContainsPasswordsEQ applies the EQ predicate on the "contains_passwords" field.
func ContainsPasswordsEQ(v bool) predicate.LocalBreach {
	return predicate.LocalBreach(sql.FieldEQ(FieldContainsPasswords, v))
}

// ContainsPasswordsNEQ applies the NEQ predicate on the "contains_passwords" field.
func ContainsPasswordsNEQ(v bool) predicate.LocalBreach {
	return predicate.LocalBreach(sql.FieldNEQ(FieldContainsPasswords, v))
}

// ContainsHashesEQ applies the EQ predicate on the "contains_hashes" field.
func ContainsHashesEQ(v bool) predicate.LocalBreach {
	return predicate.LocalBreach(sql.FieldEQ(FieldContainsHashes, v))
}

// ContainsHashesNEQ applies the NEQ predicate on the "contains_hashes" field.
func ContainsHashesNEQ(v bool) predicate.LocalBreach {
	return predicate.LocalBreach(sql.FieldNEQ(FieldContainsHashes, v))
}

// ContainsEmailsEQ applies the EQ predicate on the "contains_emails" field.
func ContainsEmailsEQ(v bool) predicate.LocalBreach {
	return predicate.LocalBreach(sql.FieldEQ(FieldContainsEmails, v))
}

// ContainsEmailsNEQ applies the NEQ predicate on the "contains_emails" field.
func ContainsEmailsNEQ(v bool) predicate.LocalBreach {
	return predicate.LocalBreach(sql.FieldNEQ(FieldContainsEmails, v))
}

// ContainsUsernamesEQ applies the EQ predicate on the "contains_usernames" field.
func ContainsUsernamesEQ(v bool) predicate.LocalBreach {
	return predicate.LocalBreach(sql.FieldEQ(FieldContainsUsernames, v))
}

// ContainsUsernamesNEQ applies the NEQ predicate on the "contains_usernames" field.
func ContainsUsernamesNEQ(v bool) predicate.LocalBreach {
	return predicate.LocalBreach(sql.FieldNEQ(FieldContainsUsernames, v))
}

// HashTypeEQ applies the EQ predicate on the "hash_type" field.
func HashTypeEQ(v string) predicate.LocalBreach {
	return predicate.LocalBreach(sql.FieldEQ(FieldHashType, v))
}

// HashTypeNEQ applies the NEQ predicate on the "hash_type" field.
func HashTypeNEQ(v string) predicate.LocalBreach {
	return predicate.LocalBreach(sql.FieldNEQ(FieldHashType, v))
}

// HashTypeIn applies the In predicate on the "hash_type" field.
func HashTypeIn(vs ...string) predicate.LocalBreach {
	return predicate.LocalBreach(sql.FieldIn(FieldHashType, vs...))
}

// HashTypeNotIn applies the NotIn predicate on the "hash_type" field.
func HashTypeNotIn(vs ...string) predicate.LocalBreach {
	return predicate.LocalBreach(sql.FieldNotIn(FieldHashType, vs...))
}

// HashTypeGT applies the GT predicate on the "hash_type" field.
func HashTypeGT(v string) predicate.LocalBreach {
	return predicate.LocalBreach(sql.FieldGT(FieldHashType, v))
}

// HashTypeGTE applies the GTE predicate on the "hash_type" field.
func HashTypeGTE(v string) predicate.LocalBreach {
	return predicate.LocalBreach(sql.FieldGTE(FieldHashType, v))
}

// HashTypeLT applies the LT predicate on the "hash_type" field.
func HashTypeLT(v string) predicate.LocalBreach {
	return predicate.LocalBreach(sql.FieldLT(FieldHashType, v))
}

// HashTypeLTE applies the LTE predicate on the "hash_type" field.
func HashTypeLTE(v string) predicate.LocalBreach {
	return predicate.LocalBreach(sql.FieldLTE(FieldHashType, v))
}

// HashTypeContains applies the Contains predicate on the "hash_type" field.
func HashTypeContains(v string) predicate.LocalBreach {
	return predicate.LocalBreach(sql.FieldContains(FieldHashType, v))
}

// HashTypeHasPrefix applies the HasPrefix predicate on the "hash_type" field.
func HashTypeHasPrefix(v string) predicate.LocalBreach {
	return predicate.LocalBreach(sql.FieldHasPrefix(FieldHashType, v))
}

// HashTypeHasSuffix applies the HasSuffix predicate on the "hash_type" field.
func HashTypeHasSuffix(v string) predicate.LocalBreach {
	return predicate.LocalBreach(sql.FieldHasSuffix(FieldHashType, v))
}

// HashTypeIsNil applies the IsNil predicate on the "hash_type" field.
func HashTypeIsNil() predicate.LocalBreach {
	return predicate.LocalBreach(sql.FieldIsNull(FieldHashType))
}

// HashTypeNotNil applies the NotNil predicate on the "hash_type" field.
func HashTypeNotNil() predicate.LocalBreach {
	return predicate.LocalBreach(sql.FieldNotNull(FieldHashType))
}

// HashTypeEqualFold applies the EqualFold predicate on the "hash_type" field.
func HashTypeEqualFold(v string) predicate.LocalBreach {
	return predicate.LocalBreach(sql.FieldEqualFold(FieldHashType, v))
}

// HashTypeContainsFold applies the ContainsFold predicate on the "hash_type" field.
func HashTypeContainsFold(v string) predicate.LocalBreach {
	return predicate.LocalBreach(sql.FieldContainsFold(FieldHashType, v))
}

// HashSaltedEQ applies the EQ predicate on the "hash_salted" field.
func HashSaltedEQ(v bool) predicate.LocalBreach {
	return predicate.LocalBreach(sql.FieldEQ(FieldHashSalted, v))
}

// HashSaltedNEQ applies the NEQ predicate on the "hash_salted" field.
func HashSaltedNEQ(v bool) predicate.LocalBreach {
	return predicate.LocalBreach(sql.FieldNEQ(FieldHashSalted, v))
}

// HashSaltedIsNil applies the IsNil predicate on the "hash_salted" field.
func HashSaltedIsNil() predicate.LocalBreach {
	return predicate.LocalBreach(sql.FieldIsNull(FieldHashSalted))
}

// HashSaltedNotNil applies the NotNil predicate on the "hash_salted" field.
func HashSaltedNotNil() predicate.LocalBreach {
	return predicate.LocalBreach(sql.FieldNotNull(FieldHashSalted))
}

// HashPepperedEQ applies the EQ predicate on the "hash_peppered" field.
func HashPepperedEQ(v bool) predicate.LocalBreach {
	return predicate.LocalBreach(sql.FieldEQ(FieldHashPeppered, v))
}

// HashPepperedNEQ applies the NEQ predicate on the "hash_peppered" field.
func HashPepperedNEQ(v bool) predicate.LocalBreach {
	return predicate.LocalBreach(sql.FieldNEQ(FieldHashPeppered, v))
}

// HashPepperedIsNil applies the IsNil predicate on the "hash_peppered" field.
func HashPepperedIsNil() predicate.LocalBreach {
	return predicate.LocalBreach(sql.FieldIsNull(FieldHashPeppered))
}

// HashPepperedNotNil applies the NotNil predicate on the "hash_peppered" field.
func HashPepperedNotNil() predicate.LocalBreach {
	return predicate.LocalBreach(sql.FieldNotNull(FieldHashPeppered))
}

// DataIsNil applies the IsNil predicate on the "data" field.
func DataIsNil() predicate.LocalBreach {
	return predicate.LocalBreach(sql.FieldIsNull(FieldData))
}

// DataNotNil applies the NotNil predicate on the "data" field.
func DataNotNil() predicate.LocalBreach {
	return predicate.LocalBreach(sql.FieldNotNull(FieldData))
}

// CreatedAtEQ applies the EQ predicate on the "created_at" field.
func CreatedAtEQ(v time.Time) predicate.LocalBreach {
	return predicate.LocalBreach(sql.FieldEQ(FieldCreatedAt, v))
}

// CreatedAtNEQ applies the NEQ predicate on the "created_at" field.
func CreatedAtNEQ(v time.Time) predicate.LocalBreach {
	return predicate.LocalBreach(sql.FieldNEQ(FieldCreatedAt, v))
}

// CreatedAtIn applies the In predicate on the "created_at" field.
func CreatedAtIn(vs ...time.Time) predicate.LocalBreach {
	return predicate.LocalBreach(sql.FieldIn(FieldCreatedAt, vs...))
}

// CreatedAtNotIn applies the NotIn predicate on the "created_at" field.
func CreatedAtNotIn(vs ...time.Time) predicate.LocalBreach {
	return predicate.LocalBreach(sql.FieldNotIn(FieldCreatedAt, vs...))
}

// CreatedAtGT applies the GT predicate on the "created_at" field.
func CreatedAtGT(v time.Time) predicate.LocalBreach {
	return predicate.LocalBreach(sql.FieldGT(FieldCreatedAt, v))
}

// CreatedAtGTE applies the GTE predicate on the "created_at" field.
func CreatedAtGTE(v time.Time) predicate.LocalBreach {
	return predicate.LocalBreach(sql.FieldGTE(FieldCreatedAt, v))
}

// CreatedAtLT applies the LT predicate on the "created_at" field.
func CreatedAtLT(v time.Time) predicate.LocalBreach {
	return predicate.LocalBreach(sql.FieldLT(FieldCreatedAt, v))
}

// CreatedAtLTE applies the LTE predicate on the "created_at" field.
func CreatedAtLTE(v time.Time) predicate.LocalBreach {
	return predicate.LocalBreach(sql.FieldLTE(FieldCreatedAt, v))
}

// HasTrackedBreaches applies the HasEdge predicate on the "tracked_breaches" edge.
func HasTrackedBreaches() predicate.LocalBreach {
	return predicate.LocalBreach(func(s *sql.Selector) {
		step := sqlgraph.NewStep(
			sqlgraph.From(Table, FieldID),
			sqlgraph.Edge(sqlgraph.M2M, true, TrackedBreachesTable, TrackedBreachesPrimaryKey...),
		)
		sqlgraph.HasNeighbors(s, step)
	})
}

// HasTrackedBreachesWith applies the HasEdge predicate on the "tracked_breaches" edge with a given conditions (other predicates).
func HasTrackedBreachesWith(preds ...predicate.TrackedBreaches) predicate.LocalBreach {
	return predicate.LocalBreach(func(s *sql.Selector) {
		step := newTrackedBreachesStep()
		sqlgraph.HasNeighborsWith(s, step, func(s *sql.Selector) {
			for _, p := range preds {
				p(s)
			}
		})
	})
}

// And groups predicates with the AND operator between them.
func And(predicates ...predicate.LocalBreach) predicate.LocalBreach {
	return predicate.LocalBreach(func(s *sql.Selector) {
		s1 := s.Clone().SetP(nil)
		for _, p := range predicates {
			p(s1)
		}
		s.Where(s1.P())
	})
}

// Or groups predicates with the OR operator between them.
func Or(predicates ...predicate.LocalBreach) predicate.LocalBreach {
	return predicate.LocalBreach(func(s *sql.Selector) {
		s1 := s.Clone().SetP(nil)
		for i, p := range predicates {
			if i > 0 {
				s1.Or()
			}
			p(s1)
		}
		s.Where(s1.P())
	})
}

// Not applies the not operator on the given predicate.
func Not(p predicate.LocalBreach) predicate.LocalBreach {
	return predicate.LocalBreach(func(s *sql.Selector) {
		p(s.Not())
	})
}
