// Code generated by ent, DO NOT EDIT.

package settings

import (
	"entgo.io/ent/dialect/sql"
	"git.dotya.ml/mirre-mt/pcmt/ent/predicate"
	"github.com/google/uuid"
)

// ID filters vertices based on their ID field.
func ID(id uuid.UUID) predicate.Settings {
	return predicate.Settings(sql.FieldEQ(FieldID, id))
}

// IDEQ applies the EQ predicate on the ID field.
func IDEQ(id uuid.UUID) predicate.Settings {
	return predicate.Settings(sql.FieldEQ(FieldID, id))
}

// IDNEQ applies the NEQ predicate on the ID field.
func IDNEQ(id uuid.UUID) predicate.Settings {
	return predicate.Settings(sql.FieldNEQ(FieldID, id))
}

// IDIn applies the In predicate on the ID field.
func IDIn(ids ...uuid.UUID) predicate.Settings {
	return predicate.Settings(sql.FieldIn(FieldID, ids...))
}

// IDNotIn applies the NotIn predicate on the ID field.
func IDNotIn(ids ...uuid.UUID) predicate.Settings {
	return predicate.Settings(sql.FieldNotIn(FieldID, ids...))
}

// IDGT applies the GT predicate on the ID field.
func IDGT(id uuid.UUID) predicate.Settings {
	return predicate.Settings(sql.FieldGT(FieldID, id))
}

// IDGTE applies the GTE predicate on the ID field.
func IDGTE(id uuid.UUID) predicate.Settings {
	return predicate.Settings(sql.FieldGTE(FieldID, id))
}

// IDLT applies the LT predicate on the ID field.
func IDLT(id uuid.UUID) predicate.Settings {
	return predicate.Settings(sql.FieldLT(FieldID, id))
}

// IDLTE applies the LTE predicate on the ID field.
func IDLTE(id uuid.UUID) predicate.Settings {
	return predicate.Settings(sql.FieldLTE(FieldID, id))
}

// HibpAPIKey applies equality check predicate on the "hibp_api_key" field. It's identical to HibpAPIKeyEQ.
func HibpAPIKey(v string) predicate.Settings {
	return predicate.Settings(sql.FieldEQ(FieldHibpAPIKey, v))
}

// DehashedAPIKey applies equality check predicate on the "dehashed_api_key" field. It's identical to DehashedAPIKeyEQ.
func DehashedAPIKey(v string) predicate.Settings {
	return predicate.Settings(sql.FieldEQ(FieldDehashedAPIKey, v))
}

// Searches applies equality check predicate on the "searches" field. It's identical to SearchesEQ.
func Searches(v uint64) predicate.Settings {
	return predicate.Settings(sql.FieldEQ(FieldSearches, v))
}

// HibpAPIKeyEQ applies the EQ predicate on the "hibp_api_key" field.
func HibpAPIKeyEQ(v string) predicate.Settings {
	return predicate.Settings(sql.FieldEQ(FieldHibpAPIKey, v))
}

// HibpAPIKeyNEQ applies the NEQ predicate on the "hibp_api_key" field.
func HibpAPIKeyNEQ(v string) predicate.Settings {
	return predicate.Settings(sql.FieldNEQ(FieldHibpAPIKey, v))
}

// HibpAPIKeyIn applies the In predicate on the "hibp_api_key" field.
func HibpAPIKeyIn(vs ...string) predicate.Settings {
	return predicate.Settings(sql.FieldIn(FieldHibpAPIKey, vs...))
}

// HibpAPIKeyNotIn applies the NotIn predicate on the "hibp_api_key" field.
func HibpAPIKeyNotIn(vs ...string) predicate.Settings {
	return predicate.Settings(sql.FieldNotIn(FieldHibpAPIKey, vs...))
}

// HibpAPIKeyGT applies the GT predicate on the "hibp_api_key" field.
func HibpAPIKeyGT(v string) predicate.Settings {
	return predicate.Settings(sql.FieldGT(FieldHibpAPIKey, v))
}

// HibpAPIKeyGTE applies the GTE predicate on the "hibp_api_key" field.
func HibpAPIKeyGTE(v string) predicate.Settings {
	return predicate.Settings(sql.FieldGTE(FieldHibpAPIKey, v))
}

// HibpAPIKeyLT applies the LT predicate on the "hibp_api_key" field.
func HibpAPIKeyLT(v string) predicate.Settings {
	return predicate.Settings(sql.FieldLT(FieldHibpAPIKey, v))
}

// HibpAPIKeyLTE applies the LTE predicate on the "hibp_api_key" field.
func HibpAPIKeyLTE(v string) predicate.Settings {
	return predicate.Settings(sql.FieldLTE(FieldHibpAPIKey, v))
}

// HibpAPIKeyContains applies the Contains predicate on the "hibp_api_key" field.
func HibpAPIKeyContains(v string) predicate.Settings {
	return predicate.Settings(sql.FieldContains(FieldHibpAPIKey, v))
}

// HibpAPIKeyHasPrefix applies the HasPrefix predicate on the "hibp_api_key" field.
func HibpAPIKeyHasPrefix(v string) predicate.Settings {
	return predicate.Settings(sql.FieldHasPrefix(FieldHibpAPIKey, v))
}

// HibpAPIKeyHasSuffix applies the HasSuffix predicate on the "hibp_api_key" field.
func HibpAPIKeyHasSuffix(v string) predicate.Settings {
	return predicate.Settings(sql.FieldHasSuffix(FieldHibpAPIKey, v))
}

// HibpAPIKeyIsNil applies the IsNil predicate on the "hibp_api_key" field.
func HibpAPIKeyIsNil() predicate.Settings {
	return predicate.Settings(sql.FieldIsNull(FieldHibpAPIKey))
}

// HibpAPIKeyNotNil applies the NotNil predicate on the "hibp_api_key" field.
func HibpAPIKeyNotNil() predicate.Settings {
	return predicate.Settings(sql.FieldNotNull(FieldHibpAPIKey))
}

// HibpAPIKeyEqualFold applies the EqualFold predicate on the "hibp_api_key" field.
func HibpAPIKeyEqualFold(v string) predicate.Settings {
	return predicate.Settings(sql.FieldEqualFold(FieldHibpAPIKey, v))
}

// HibpAPIKeyContainsFold applies the ContainsFold predicate on the "hibp_api_key" field.
func HibpAPIKeyContainsFold(v string) predicate.Settings {
	return predicate.Settings(sql.FieldContainsFold(FieldHibpAPIKey, v))
}

// DehashedAPIKeyEQ applies the EQ predicate on the "dehashed_api_key" field.
func DehashedAPIKeyEQ(v string) predicate.Settings {
	return predicate.Settings(sql.FieldEQ(FieldDehashedAPIKey, v))
}

// DehashedAPIKeyNEQ applies the NEQ predicate on the "dehashed_api_key" field.
func DehashedAPIKeyNEQ(v string) predicate.Settings {
	return predicate.Settings(sql.FieldNEQ(FieldDehashedAPIKey, v))
}

// DehashedAPIKeyIn applies the In predicate on the "dehashed_api_key" field.
func DehashedAPIKeyIn(vs ...string) predicate.Settings {
	return predicate.Settings(sql.FieldIn(FieldDehashedAPIKey, vs...))
}

// DehashedAPIKeyNotIn applies the NotIn predicate on the "dehashed_api_key" field.
func DehashedAPIKeyNotIn(vs ...string) predicate.Settings {
	return predicate.Settings(sql.FieldNotIn(FieldDehashedAPIKey, vs...))
}

// DehashedAPIKeyGT applies the GT predicate on the "dehashed_api_key" field.
func DehashedAPIKeyGT(v string) predicate.Settings {
	return predicate.Settings(sql.FieldGT(FieldDehashedAPIKey, v))
}

// DehashedAPIKeyGTE applies the GTE predicate on the "dehashed_api_key" field.
func DehashedAPIKeyGTE(v string) predicate.Settings {
	return predicate.Settings(sql.FieldGTE(FieldDehashedAPIKey, v))
}

// DehashedAPIKeyLT applies the LT predicate on the "dehashed_api_key" field.
func DehashedAPIKeyLT(v string) predicate.Settings {
	return predicate.Settings(sql.FieldLT(FieldDehashedAPIKey, v))
}

// DehashedAPIKeyLTE applies the LTE predicate on the "dehashed_api_key" field.
func DehashedAPIKeyLTE(v string) predicate.Settings {
	return predicate.Settings(sql.FieldLTE(FieldDehashedAPIKey, v))
}

// DehashedAPIKeyContains applies the Contains predicate on the "dehashed_api_key" field.
func DehashedAPIKeyContains(v string) predicate.Settings {
	return predicate.Settings(sql.FieldContains(FieldDehashedAPIKey, v))
}

// DehashedAPIKeyHasPrefix applies the HasPrefix predicate on the "dehashed_api_key" field.
func DehashedAPIKeyHasPrefix(v string) predicate.Settings {
	return predicate.Settings(sql.FieldHasPrefix(FieldDehashedAPIKey, v))
}

// DehashedAPIKeyHasSuffix applies the HasSuffix predicate on the "dehashed_api_key" field.
func DehashedAPIKeyHasSuffix(v string) predicate.Settings {
	return predicate.Settings(sql.FieldHasSuffix(FieldDehashedAPIKey, v))
}

// DehashedAPIKeyIsNil applies the IsNil predicate on the "dehashed_api_key" field.
func DehashedAPIKeyIsNil() predicate.Settings {
	return predicate.Settings(sql.FieldIsNull(FieldDehashedAPIKey))
}

// DehashedAPIKeyNotNil applies the NotNil predicate on the "dehashed_api_key" field.
func DehashedAPIKeyNotNil() predicate.Settings {
	return predicate.Settings(sql.FieldNotNull(FieldDehashedAPIKey))
}

// DehashedAPIKeyEqualFold applies the EqualFold predicate on the "dehashed_api_key" field.
func DehashedAPIKeyEqualFold(v string) predicate.Settings {
	return predicate.Settings(sql.FieldEqualFold(FieldDehashedAPIKey, v))
}

// DehashedAPIKeyContainsFold applies the ContainsFold predicate on the "dehashed_api_key" field.
func DehashedAPIKeyContainsFold(v string) predicate.Settings {
	return predicate.Settings(sql.FieldContainsFold(FieldDehashedAPIKey, v))
}

// SearchesEQ applies the EQ predicate on the "searches" field.
func SearchesEQ(v uint64) predicate.Settings {
	return predicate.Settings(sql.FieldEQ(FieldSearches, v))
}

// SearchesNEQ applies the NEQ predicate on the "searches" field.
func SearchesNEQ(v uint64) predicate.Settings {
	return predicate.Settings(sql.FieldNEQ(FieldSearches, v))
}

// SearchesIn applies the In predicate on the "searches" field.
func SearchesIn(vs ...uint64) predicate.Settings {
	return predicate.Settings(sql.FieldIn(FieldSearches, vs...))
}

// SearchesNotIn applies the NotIn predicate on the "searches" field.
func SearchesNotIn(vs ...uint64) predicate.Settings {
	return predicate.Settings(sql.FieldNotIn(FieldSearches, vs...))
}

// SearchesGT applies the GT predicate on the "searches" field.
func SearchesGT(v uint64) predicate.Settings {
	return predicate.Settings(sql.FieldGT(FieldSearches, v))
}

// SearchesGTE applies the GTE predicate on the "searches" field.
func SearchesGTE(v uint64) predicate.Settings {
	return predicate.Settings(sql.FieldGTE(FieldSearches, v))
}

// SearchesLT applies the LT predicate on the "searches" field.
func SearchesLT(v uint64) predicate.Settings {
	return predicate.Settings(sql.FieldLT(FieldSearches, v))
}

// SearchesLTE applies the LTE predicate on the "searches" field.
func SearchesLTE(v uint64) predicate.Settings {
	return predicate.Settings(sql.FieldLTE(FieldSearches, v))
}

// And groups predicates with the AND operator between them.
func And(predicates ...predicate.Settings) predicate.Settings {
	return predicate.Settings(func(s *sql.Selector) {
		s1 := s.Clone().SetP(nil)
		for _, p := range predicates {
			p(s1)
		}
		s.Where(s1.P())
	})
}

// Or groups predicates with the OR operator between them.
func Or(predicates ...predicate.Settings) predicate.Settings {
	return predicate.Settings(func(s *sql.Selector) {
		s1 := s.Clone().SetP(nil)
		for i, p := range predicates {
			if i > 0 {
				s1.Or()
			}
			p(s1)
		}
		s.Where(s1.P())
	})
}

// Not applies the not operator on the given predicate.
func Not(p predicate.Settings) predicate.Settings {
	return predicate.Settings(func(s *sql.Selector) {
		p(s.Not())
	})
}
