// Code generated by ent, DO NOT EDIT.

package trackedbreaches

import (
	"entgo.io/ent/dialect/sql"
	"entgo.io/ent/dialect/sql/sqlgraph"
	"git.dotya.ml/mirre-mt/pcmt/ent/predicate"
	"github.com/google/uuid"
)

// ID filters vertices based on their ID field.
func ID(id uuid.UUID) predicate.TrackedBreaches {
	return predicate.TrackedBreaches(sql.FieldEQ(FieldID, id))
}

// IDEQ applies the EQ predicate on the ID field.
func IDEQ(id uuid.UUID) predicate.TrackedBreaches {
	return predicate.TrackedBreaches(sql.FieldEQ(FieldID, id))
}

// IDNEQ applies the NEQ predicate on the ID field.
func IDNEQ(id uuid.UUID) predicate.TrackedBreaches {
	return predicate.TrackedBreaches(sql.FieldNEQ(FieldID, id))
}

// IDIn applies the In predicate on the ID field.
func IDIn(ids ...uuid.UUID) predicate.TrackedBreaches {
	return predicate.TrackedBreaches(sql.FieldIn(FieldID, ids...))
}

// IDNotIn applies the NotIn predicate on the ID field.
func IDNotIn(ids ...uuid.UUID) predicate.TrackedBreaches {
	return predicate.TrackedBreaches(sql.FieldNotIn(FieldID, ids...))
}

// IDGT applies the GT predicate on the ID field.
func IDGT(id uuid.UUID) predicate.TrackedBreaches {
	return predicate.TrackedBreaches(sql.FieldGT(FieldID, id))
}

// IDGTE applies the GTE predicate on the ID field.
func IDGTE(id uuid.UUID) predicate.TrackedBreaches {
	return predicate.TrackedBreaches(sql.FieldGTE(FieldID, id))
}

// IDLT applies the LT predicate on the ID field.
func IDLT(id uuid.UUID) predicate.TrackedBreaches {
	return predicate.TrackedBreaches(sql.FieldLT(FieldID, id))
}

// IDLTE applies the LTE predicate on the ID field.
func IDLTE(id uuid.UUID) predicate.TrackedBreaches {
	return predicate.TrackedBreaches(sql.FieldLTE(FieldID, id))
}

// Breach applies equality check predicate on the "breach" field. It's identical to BreachEQ.
func Breach(v uuid.UUID) predicate.TrackedBreaches {
	return predicate.TrackedBreaches(sql.FieldEQ(FieldBreach, v))
}

// Online applies equality check predicate on the "online" field. It's identical to OnlineEQ.
func Online(v bool) predicate.TrackedBreaches {
	return predicate.TrackedBreaches(sql.FieldEQ(FieldOnline, v))
}

// Owner applies equality check predicate on the "owner" field. It's identical to OwnerEQ.
func Owner(v uuid.UUID) predicate.TrackedBreaches {
	return predicate.TrackedBreaches(sql.FieldEQ(FieldOwner, v))
}

// BreachEQ applies the EQ predicate on the "breach" field.
func BreachEQ(v uuid.UUID) predicate.TrackedBreaches {
	return predicate.TrackedBreaches(sql.FieldEQ(FieldBreach, v))
}

// BreachNEQ applies the NEQ predicate on the "breach" field.
func BreachNEQ(v uuid.UUID) predicate.TrackedBreaches {
	return predicate.TrackedBreaches(sql.FieldNEQ(FieldBreach, v))
}

// BreachIn applies the In predicate on the "breach" field.
func BreachIn(vs ...uuid.UUID) predicate.TrackedBreaches {
	return predicate.TrackedBreaches(sql.FieldIn(FieldBreach, vs...))
}

// BreachNotIn applies the NotIn predicate on the "breach" field.
func BreachNotIn(vs ...uuid.UUID) predicate.TrackedBreaches {
	return predicate.TrackedBreaches(sql.FieldNotIn(FieldBreach, vs...))
}

// BreachGT applies the GT predicate on the "breach" field.
func BreachGT(v uuid.UUID) predicate.TrackedBreaches {
	return predicate.TrackedBreaches(sql.FieldGT(FieldBreach, v))
}

// BreachGTE applies the GTE predicate on the "breach" field.
func BreachGTE(v uuid.UUID) predicate.TrackedBreaches {
	return predicate.TrackedBreaches(sql.FieldGTE(FieldBreach, v))
}

// BreachLT applies the LT predicate on the "breach" field.
func BreachLT(v uuid.UUID) predicate.TrackedBreaches {
	return predicate.TrackedBreaches(sql.FieldLT(FieldBreach, v))
}

// BreachLTE applies the LTE predicate on the "breach" field.
func BreachLTE(v uuid.UUID) predicate.TrackedBreaches {
	return predicate.TrackedBreaches(sql.FieldLTE(FieldBreach, v))
}

// OnlineEQ applies the EQ predicate on the "online" field.
func OnlineEQ(v bool) predicate.TrackedBreaches {
	return predicate.TrackedBreaches(sql.FieldEQ(FieldOnline, v))
}

// OnlineNEQ applies the NEQ predicate on the "online" field.
func OnlineNEQ(v bool) predicate.TrackedBreaches {
	return predicate.TrackedBreaches(sql.FieldNEQ(FieldOnline, v))
}

// OwnerEQ applies the EQ predicate on the "owner" field.
func OwnerEQ(v uuid.UUID) predicate.TrackedBreaches {
	return predicate.TrackedBreaches(sql.FieldEQ(FieldOwner, v))
}

// OwnerNEQ applies the NEQ predicate on the "owner" field.
func OwnerNEQ(v uuid.UUID) predicate.TrackedBreaches {
	return predicate.TrackedBreaches(sql.FieldNEQ(FieldOwner, v))
}

// OwnerIn applies the In predicate on the "owner" field.
func OwnerIn(vs ...uuid.UUID) predicate.TrackedBreaches {
	return predicate.TrackedBreaches(sql.FieldIn(FieldOwner, vs...))
}

// OwnerNotIn applies the NotIn predicate on the "owner" field.
func OwnerNotIn(vs ...uuid.UUID) predicate.TrackedBreaches {
	return predicate.TrackedBreaches(sql.FieldNotIn(FieldOwner, vs...))
}

// HasUser applies the HasEdge predicate on the "user" edge.
func HasUser() predicate.TrackedBreaches {
	return predicate.TrackedBreaches(func(s *sql.Selector) {
		step := sqlgraph.NewStep(
			sqlgraph.From(Table, FieldID),
			sqlgraph.Edge(sqlgraph.M2O, true, UserTable, UserColumn),
		)
		sqlgraph.HasNeighbors(s, step)
	})
}

// HasUserWith applies the HasEdge predicate on the "user" edge with a given conditions (other predicates).
func HasUserWith(preds ...predicate.User) predicate.TrackedBreaches {
	return predicate.TrackedBreaches(func(s *sql.Selector) {
		step := newUserStep()
		sqlgraph.HasNeighborsWith(s, step, func(s *sql.Selector) {
			for _, p := range preds {
				p(s)
			}
		})
	})
}

// HasLocalbreach applies the HasEdge predicate on the "localbreach" edge.
func HasLocalbreach() predicate.TrackedBreaches {
	return predicate.TrackedBreaches(func(s *sql.Selector) {
		step := sqlgraph.NewStep(
			sqlgraph.From(Table, FieldID),
			sqlgraph.Edge(sqlgraph.M2M, false, LocalbreachTable, LocalbreachPrimaryKey...),
		)
		sqlgraph.HasNeighbors(s, step)
	})
}

// HasLocalbreachWith applies the HasEdge predicate on the "localbreach" edge with a given conditions (other predicates).
func HasLocalbreachWith(preds ...predicate.LocalBreach) predicate.TrackedBreaches {
	return predicate.TrackedBreaches(func(s *sql.Selector) {
		step := newLocalbreachStep()
		sqlgraph.HasNeighborsWith(s, step, func(s *sql.Selector) {
			for _, p := range preds {
				p(s)
			}
		})
	})
}

// HasHibp applies the HasEdge predicate on the "hibp" edge.
func HasHibp() predicate.TrackedBreaches {
	return predicate.TrackedBreaches(func(s *sql.Selector) {
		step := sqlgraph.NewStep(
			sqlgraph.From(Table, FieldID),
			sqlgraph.Edge(sqlgraph.O2M, false, HibpTable, HibpColumn),
		)
		sqlgraph.HasNeighbors(s, step)
	})
}

// HasHibpWith applies the HasEdge predicate on the "hibp" edge with a given conditions (other predicates).
func HasHibpWith(preds ...predicate.HIBP) predicate.TrackedBreaches {
	return predicate.TrackedBreaches(func(s *sql.Selector) {
		step := newHibpStep()
		sqlgraph.HasNeighborsWith(s, step, func(s *sql.Selector) {
			for _, p := range preds {
				p(s)
			}
		})
	})
}

// And groups predicates with the AND operator between them.
func And(predicates ...predicate.TrackedBreaches) predicate.TrackedBreaches {
	return predicate.TrackedBreaches(func(s *sql.Selector) {
		s1 := s.Clone().SetP(nil)
		for _, p := range predicates {
			p(s1)
		}
		s.Where(s1.P())
	})
}

// Or groups predicates with the OR operator between them.
func Or(predicates ...predicate.TrackedBreaches) predicate.TrackedBreaches {
	return predicate.TrackedBreaches(func(s *sql.Selector) {
		s1 := s.Clone().SetP(nil)
		for i, p := range predicates {
			if i > 0 {
				s1.Or()
			}
			p(s1)
		}
		s.Where(s1.P())
	})
}

// Not applies the not operator on the given predicate.
func Not(p predicate.TrackedBreaches) predicate.TrackedBreaches {
	return predicate.TrackedBreaches(func(s *sql.Selector) {
		p(s.Not())
	})
}
