// Code generated by ent, DO NOT EDIT.

package user

import (
	"time"

	"entgo.io/ent/dialect/sql"
	"entgo.io/ent/dialect/sql/sqlgraph"
	"github.com/google/uuid"
)

const (
	// Label holds the string label denoting the user type in the database.
	Label = "user"
	// FieldID holds the string denoting the id field in the database.
	FieldID = "id"
	// FieldUsername holds the string denoting the username field in the database.
	FieldUsername = "username"
	// FieldEmail holds the string denoting the email field in the database.
	FieldEmail = "email"
	// FieldPassword holds the string denoting the password field in the database.
	FieldPassword = "password"
	// FieldIsAdmin holds the string denoting the is_admin field in the database.
	FieldIsAdmin = "is_admin"
	// FieldIsActive holds the string denoting the is_active field in the database.
	FieldIsActive = "is_active"
	// FieldCreatedAt holds the string denoting the created_at field in the database.
	FieldCreatedAt = "created_at"
	// FieldUpdatedAt holds the string denoting the updated_at field in the database.
	FieldUpdatedAt = "updated_at"
	// FieldLastLogin holds the string denoting the last_login field in the database.
	FieldLastLogin = "last_login"
	// EdgeAgekey holds the string denoting the agekey edge name in mutations.
	EdgeAgekey = "agekey"
	// EdgeTrackedBreaches holds the string denoting the tracked_breaches edge name in mutations.
	EdgeTrackedBreaches = "tracked_breaches"
	// EdgeSearchQueries holds the string denoting the search_queries edge name in mutations.
	EdgeSearchQueries = "search_queries"
	// Table holds the table name of the user in the database.
	Table = "users"
	// AgekeyTable is the table that holds the agekey relation/edge.
	AgekeyTable = "age_keys"
	// AgekeyInverseTable is the table name for the AgeKey entity.
	// It exists in this package in order to avoid circular dependency with the "agekey" package.
	AgekeyInverseTable = "age_keys"
	// AgekeyColumn is the table column denoting the agekey relation/edge.
	AgekeyColumn = "owner"
	// TrackedBreachesTable is the table that holds the tracked_breaches relation/edge.
	TrackedBreachesTable = "tracked_breaches"
	// TrackedBreachesInverseTable is the table name for the TrackedBreaches entity.
	// It exists in this package in order to avoid circular dependency with the "trackedbreaches" package.
	TrackedBreachesInverseTable = "tracked_breaches"
	// TrackedBreachesColumn is the table column denoting the tracked_breaches relation/edge.
	TrackedBreachesColumn = "owner"
	// SearchQueriesTable is the table that holds the search_queries relation/edge.
	SearchQueriesTable = "search_queries"
	// SearchQueriesInverseTable is the table name for the SearchQuery entity.
	// It exists in this package in order to avoid circular dependency with the "searchquery" package.
	SearchQueriesInverseTable = "search_queries"
	// SearchQueriesColumn is the table column denoting the search_queries relation/edge.
	SearchQueriesColumn = "owner"
)

// Columns holds all SQL columns for user fields.
var Columns = []string{
	FieldID,
	FieldUsername,
	FieldEmail,
	FieldPassword,
	FieldIsAdmin,
	FieldIsActive,
	FieldCreatedAt,
	FieldUpdatedAt,
	FieldLastLogin,
}

// ValidColumn reports if the column name is valid (part of the table columns).
func ValidColumn(column string) bool {
	for i := range Columns {
		if column == Columns[i] {
			return true
		}
	}
	return false
}

var (
	// UsernameValidator is a validator for the "username" field. It is called by the builders before save.
	UsernameValidator func(string) error
	// EmailValidator is a validator for the "email" field. It is called by the builders before save.
	EmailValidator func(string) error
	// PasswordValidator is a validator for the "password" field. It is called by the builders before save.
	PasswordValidator func([]byte) error
	// DefaultIsAdmin holds the default value on creation for the "is_admin" field.
	DefaultIsAdmin bool
	// DefaultIsActive holds the default value on creation for the "is_active" field.
	DefaultIsActive bool
	// DefaultCreatedAt holds the default value on creation for the "created_at" field.
	DefaultCreatedAt func() time.Time
	// DefaultUpdatedAt holds the default value on creation for the "updated_at" field.
	DefaultUpdatedAt func() time.Time
	// UpdateDefaultUpdatedAt holds the default value on update for the "updated_at" field.
	UpdateDefaultUpdatedAt func() time.Time
	// DefaultLastLogin holds the default value on creation for the "last_login" field.
	DefaultLastLogin time.Time
	// DefaultID holds the default value on creation for the "id" field.
	DefaultID func() uuid.UUID
)

// OrderOption defines the ordering options for the User queries.
type OrderOption func(*sql.Selector)

// ByID orders the results by the id field.
func ByID(opts ...sql.OrderTermOption) OrderOption {
	return sql.OrderByField(FieldID, opts...).ToFunc()
}

// ByUsername orders the results by the username field.
func ByUsername(opts ...sql.OrderTermOption) OrderOption {
	return sql.OrderByField(FieldUsername, opts...).ToFunc()
}

// ByEmail orders the results by the email field.
func ByEmail(opts ...sql.OrderTermOption) OrderOption {
	return sql.OrderByField(FieldEmail, opts...).ToFunc()
}

// ByIsAdmin orders the results by the is_admin field.
func ByIsAdmin(opts ...sql.OrderTermOption) OrderOption {
	return sql.OrderByField(FieldIsAdmin, opts...).ToFunc()
}

// ByIsActive orders the results by the is_active field.
func ByIsActive(opts ...sql.OrderTermOption) OrderOption {
	return sql.OrderByField(FieldIsActive, opts...).ToFunc()
}

// ByCreatedAt orders the results by the created_at field.
func ByCreatedAt(opts ...sql.OrderTermOption) OrderOption {
	return sql.OrderByField(FieldCreatedAt, opts...).ToFunc()
}

// ByUpdatedAt orders the results by the updated_at field.
func ByUpdatedAt(opts ...sql.OrderTermOption) OrderOption {
	return sql.OrderByField(FieldUpdatedAt, opts...).ToFunc()
}

// ByLastLogin orders the results by the last_login field.
func ByLastLogin(opts ...sql.OrderTermOption) OrderOption {
	return sql.OrderByField(FieldLastLogin, opts...).ToFunc()
}

// ByAgekeyField orders the results by agekey field.
func ByAgekeyField(field string, opts ...sql.OrderTermOption) OrderOption {
	return func(s *sql.Selector) {
		sqlgraph.OrderByNeighborTerms(s, newAgekeyStep(), sql.OrderByField(field, opts...))
	}
}

// ByTrackedBreachesCount orders the results by tracked_breaches count.
func ByTrackedBreachesCount(opts ...sql.OrderTermOption) OrderOption {
	return func(s *sql.Selector) {
		sqlgraph.OrderByNeighborsCount(s, newTrackedBreachesStep(), opts...)
	}
}

// ByTrackedBreaches orders the results by tracked_breaches terms.
func ByTrackedBreaches(term sql.OrderTerm, terms ...sql.OrderTerm) OrderOption {
	return func(s *sql.Selector) {
		sqlgraph.OrderByNeighborTerms(s, newTrackedBreachesStep(), append([]sql.OrderTerm{term}, terms...)...)
	}
}

// BySearchQueriesCount orders the results by search_queries count.
func BySearchQueriesCount(opts ...sql.OrderTermOption) OrderOption {
	return func(s *sql.Selector) {
		sqlgraph.OrderByNeighborsCount(s, newSearchQueriesStep(), opts...)
	}
}

// BySearchQueries orders the results by search_queries terms.
func BySearchQueries(term sql.OrderTerm, terms ...sql.OrderTerm) OrderOption {
	return func(s *sql.Selector) {
		sqlgraph.OrderByNeighborTerms(s, newSearchQueriesStep(), append([]sql.OrderTerm{term}, terms...)...)
	}
}
func newAgekeyStep() *sqlgraph.Step {
	return sqlgraph.NewStep(
		sqlgraph.From(Table, FieldID),
		sqlgraph.To(AgekeyInverseTable, FieldID),
		sqlgraph.Edge(sqlgraph.O2O, false, AgekeyTable, AgekeyColumn),
	)
}
func newTrackedBreachesStep() *sqlgraph.Step {
	return sqlgraph.NewStep(
		sqlgraph.From(Table, FieldID),
		sqlgraph.To(TrackedBreachesInverseTable, FieldID),
		sqlgraph.Edge(sqlgraph.O2M, false, TrackedBreachesTable, TrackedBreachesColumn),
	)
}
func newSearchQueriesStep() *sqlgraph.Step {
	return sqlgraph.NewStep(
		sqlgraph.From(Table, FieldID),
		sqlgraph.To(SearchQueriesInverseTable, FieldID),
		sqlgraph.Edge(sqlgraph.O2M, false, SearchQueriesTable, SearchQueriesColumn),
	)
}
